"use strict";

exports.__esModule = true;
exports.default = void 0;

var _esModuleLexer = require("es-module-lexer");

var _unistUtilFlatmap = _interopRequireDefault(require("unist-util-flatmap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @ts-ignore
const parseProps = node => {
  return node.meta && node.meta.split(' ').reduce((acc, cur) => {
    if (cur.split('=').length > 1) {
      const t = cur.split('=');
      acc[t[0]] = t[1];
      return acc;
    }

    acc[cur] = true;
    return acc;
  }, {});
};

const reg = /import\s+?(?:(?:(?:[\w*\s{},]*)\s+from\s+?)|)(?:(?:".*?")|(?:'.*?'))[\s]*?(?:;|$|)/g;

var _default = () => async (tree, file) => {
  await _esModuleLexer.init;
  let addImport = false;
  let chunkName = 'jarle-imports';
  if (file != null && file.history.length) chunkName += `-${file.history[0].replace(file.cwd, '').replace(/\//g, '-')}`;
  (0, _unistUtilFlatmap.default)(tree, node => {
    if (node.type !== 'code') return [node];
    const meta = parseProps(node) || {};

    if (!meta.live) {
      return [node];
    }

    let keys = '';

    for (const [str] of node.value.matchAll(reg)) {
      const [imports] = (0, _esModuleLexer.parse)(str);
      const req = str.substring(imports[0].s, imports[0].e);
      keys += `"${req}": import(/* webpackChunkName: "${chunkName}" */ '${req}'),\n`;
    }

    if (!keys.length) {
      return [node];
    }

    addImport = true;
    return [{
      type: 'jsx',
      value: `<ImportContext imports={() => allValues({\n${keys}\n})}>`
    }, node, {
      type: 'jsx',
      value: '</ImportContext>'
    }];
  });

  if (addImport) {
    tree.children.unshift({
      type: 'import',
      value: 'import ImportContext, { allValues } from "@theme/ImportContext";'
    });
  }

  return tree;
};

exports.default = _default;