"use strict";

exports.__esModule = true;
exports.default = void 0;

var _BrowserOnly = _interopRequireDefault(require("@docusaurus/BrowserOnly"));

var _ImportContext = require("@theme/ImportContext");

var _clsx = _interopRequireDefault(require("clsx"));

var _jarle = require("jarle");

var React = _interopRequireWildcard(require("react"));

var _stylesModule = _interopRequireDefault(require("./styles.module.css"));

var _jsxRuntime = require("react/jsx-runtime");

const _excluded = ["children", "inline", "className", "editorClassName", "previewClassName", "errorClassName", "codeFirst", "prismTheme", "editor"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const Info = props => /*#__PURE__*/(0, _jsxRuntime.jsx)(_jarle.InfoMessage, Object.assign({}, props, {
  className: (0, _clsx.default)(props.className, _stylesModule.default.infoMessage)
}));

const Playground = /*#__PURE__*/React.forwardRef((_ref, ref) => {
  let {
    children,
    inline = false,
    className,
    editorClassName,
    previewClassName,
    errorClassName,
    codeFirst = false,
    prismTheme,
    editor: editorConfig = 'show'
  } = _ref,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  const resolveImports = React.useContext(_ImportContext.Context);
  const [showEditor, setShowEditor] = React.useState(editorConfig === 'show');
  const showButton = editorConfig === 'collapse' && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)("button", {
      className: _stylesModule.default.playgroundButton,
      onClick: () => setShowEditor(prev => !prev),
      children: [showEditor ? 'Hide' : 'Show', " Code"]
    })
  });
  const editor = showEditor && /*#__PURE__*/(0, _jsxRuntime.jsx)(_jarle.Editor, {
    infoComponent: Info,
    className: (0, _clsx.default)(editorClassName, _stylesModule.default.playgroundEditor)
  });
  const preview = /*#__PURE__*/(0, _jsxRuntime.jsx)(_BrowserOnly.default, {
    fallback: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      children: "Loading\u2026"
    }),
    children: () => /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: (0, _clsx.default)(previewClassName, _stylesModule.default.playgroundPreview),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_jarle.Preview, {}), /*#__PURE__*/(0, _jsxRuntime.jsx)(_jarle.Error, {
        className: (0, _clsx.default)(errorClassName, _stylesModule.default.error)
      })]
    })
  });
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      ref: ref,
      className: (0, _clsx.default)(className, _stylesModule.default.playground, inline && _stylesModule.default.inline),
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_jarle.Provider, Object.assign({
        code: children.replace(/\n$/, ''),
        theme: prismTheme,
        resolveImports: resolveImports != null ? resolveImports : undefined
      }, props, {
        children: !codeFirst ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
          children: [preview, editor]
        }) : /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
          children: [editor, preview]
        })
      }))
    }), showButton]
  });
});
Playground.displayName = 'Playground';
var _default = Playground;
exports.default = _default;